;;;********************************************************************
;;;                    
;;;                             KS_Rect.lsp v.2
;;;                 Copyright,2002        ..
;;;                           AutoCAD 2000 (15)
;;;                           Kv
;;;                   
;;;                               8.07.02
;;;********************************************************************

(defun c:ks_rect ( / pr p1 p2 p3 p4 p5 akv bkv cmd blm sosnap)
  (setq cmd (getvar "CMDECHO")
        blm (getvar "BLIPMODE")
	sosnap	(getvar "osmode")
        pr (strcase (getstring "\n  <L>,  <R>,  <U>,  <D>    <C>  : <C> "))
  )
  (initget 3) 
  (cond ((or (= pr "C") (= pr "")) (perc_re) )
        (      (= pr "L")          (perl_re) )
	(      (= pr "R")          (perr_re) )
	(      (= pr "U")          (peru_re) )
	(      (= pr "D")          (perd_re) )
  )
  
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blm)
  (setvar "osmode" sosnap)
  (setq  pr nil  p1 nil  p2 nil  p3 nil p4 nil   p5 nil 
         akv nil  bkv nil sosnap nil  cmd nil  blm nil
  )
  (princ)
)

;===== =====

(defun obshee_re ()
  (setq p3 (list (car p2)        (+(cadr p2) bkv))
        p4 (list (+(car p3) akv) (cadr p3)       )
        p5 (list (car p4)        (cadr p2)       )
  )
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osmode" 0)
)

;=====  =====

(defun perc_re ( )
  (setq p1 (getpoint "\n : ")
        akv (getdist p1 "\n  A: ")
        bkv (getdist p1 "\n  B: ")
        p2 (list (- (car p1) (/ akv 2.0)) (- (cadr p1) (/ bkv 2.0)))
  )
  (obshee_re)
  (command "line" p2 p3 "")
  (command "line" p3 p4 "")
  (command "line" p4 p5 "")
  (command "line" p2 p5 "")
)

;=====     =====

(defun perl_re ( )
  (setq p1 (getpoint "\n  : ")
        akv  (getdist p1 "\n  A: ")
        bkv  (getdist p1 "\n  B: ")
        p2 (list (car p1) (- (cadr p1) (/ bkv 2.0)))
  )
  (obshee_re)
  (setq pr1 (getstring "\n   (Y/N) ? <N>")
  )
  (command "line" p3 p4 "")
  (command "line" p4 p5 "")
  (command "line" p2 p5 "")
  (if (or (= pr1 "y") (= pr1 "Y")) (command "line" p2 p3 ""))
)

;=====     =====

(defun perr_re ( )
  (setq p1 (getpoint "\n  : ")
        akv (getdist p1 "\n  A: ")
        bkv (getdist p1 "\n  B: ")
        p2 (list (- (car p1) akv) (- (cadr p1) (/ bkv 2.0)))
  )
  (obshee_re)
  (setq pr1 (getstring "\n   (Y/N) ? <N>")
  )
  (command "line" p2 p3 "")
  (command "line" p3 p4 "")
  (command "line" p2 p5 "")
  (if (or (= pr1 "y") (= pr1 "Y")) (command "line" p4 p5 ""))
)

;=====     =====

(defun peru_re ( )
  (setq p1 (getpoint "\n  : ")
        akv  (getdist p1 "\n  A: ")
        bkv  (getdist p1 "\n  B: ")
        p2 (list (- (car p1) (/ akv 2.0)) (- (cadr p1) bkv))
  )
  (obshee_re)
  (setq pr1 (getstring "\n   (Y/N) ? <N>")
  )
  (command "line" p2 p3 "")
  (command "line" p4 p5 "")
  (command "line" p2 p5 "")
  (if (or (= pr1 "y") (= pr1 "Y")) (command "line" p3 p4 ""))
)

;=====     =====

(defun perd_re ( )
  (setq p1 (getpoint "\n  : ")
        akv  (getdist p1 "\n  A: ")
        bkv  (getdist p1 "\n  B: ")
        p2 (list (- (car p1) (/ akv 2.0)) (cadr p1))
  )
  (obshee_re)
  (setq pr1 (getstring "\n   (Y/N) ? <N>")
  )
  (command "line" p2 p3 "")
  (command "line" p3 p4 "")
  (command "line" p4 p5 "")
  (if (or (= pr1 "y") (= pr1 "Y")) (command "line" p2 p5 ""))
)